<!DOCTYPE html>

<html>

<head>

<meta charset="utf-8" />
<meta name="generator" content="pandoc" />
<meta http-equiv="X-UA-Compatible" content="IE=EDGE" />

<meta name="viewport" content="width=device-width, initial-scale=1" />


<meta name="date" content="2020-07-01" />

<title>Troubleshooting with glmmTMB</title>



<style type="text/css">code{white-space: pre;}</style>
<style type="text/css" data-origin="pandoc">
div.sourceCode { overflow-x: auto; }
table.sourceCode, tr.sourceCode, td.lineNumbers, td.sourceCode {
  margin: 0; padding: 0; vertical-align: baseline; border: none; }
table.sourceCode { width: 100%; line-height: 100%; }
td.lineNumbers { text-align: right; padding-right: 4px; padding-left: 4px; color: #aaaaaa; border-right: 1px solid #aaaaaa; }
td.sourceCode { padding-left: 5px; }
code > span.kw { color: #007020; font-weight: bold; } /* Keyword */
code > span.dt { color: #902000; } /* DataType */
code > span.dv { color: #40a070; } /* DecVal */
code > span.bn { color: #40a070; } /* BaseN */
code > span.fl { color: #40a070; } /* Float */
code > span.ch { color: #4070a0; } /* Char */
code > span.st { color: #4070a0; } /* String */
code > span.co { color: #60a0b0; font-style: italic; } /* Comment */
code > span.ot { color: #007020; } /* Other */
code > span.al { color: #ff0000; font-weight: bold; } /* Alert */
code > span.fu { color: #06287e; } /* Function */
code > span.er { color: #ff0000; font-weight: bold; } /* Error */
code > span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
code > span.cn { color: #880000; } /* Constant */
code > span.sc { color: #4070a0; } /* SpecialChar */
code > span.vs { color: #4070a0; } /* VerbatimString */
code > span.ss { color: #bb6688; } /* SpecialString */
code > span.im { } /* Import */
code > span.va { color: #19177c; } /* Variable */
code > span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code > span.op { color: #666666; } /* Operator */
code > span.bu { } /* BuiltIn */
code > span.ex { } /* Extension */
code > span.pp { color: #bc7a00; } /* Preprocessor */
code > span.at { color: #7d9029; } /* Attribute */
code > span.do { color: #ba2121; font-style: italic; } /* Documentation */
code > span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code > span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code > span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */

</style>
<script>
// apply pandoc div.sourceCode style to pre.sourceCode instead
(function() {
  var sheets = document.styleSheets;
  for (var i = 0; i < sheets.length; i++) {
    if (sheets[i].ownerNode.dataset["origin"] !== "pandoc") continue;
    try { var rules = sheets[i].cssRules; } catch (e) { continue; }
    for (var j = 0; j < rules.length; j++) {
      var rule = rules[j];
      // check if there is a div.sourceCode rule
      if (rule.type !== rule.STYLE_RULE || rule.selectorText !== "div.sourceCode") continue;
      var style = rule.style.cssText;
      // check if color or background-color is set
      if (rule.style.color === '' && rule.style.backgroundColor === '') continue;
      // replace div.sourceCode by a pre.sourceCode rule
      sheets[i].deleteRule(j);
      sheets[i].insertRule('pre.sourceCode{' + style + '}', j);
    }
  }
})();
</script>



<link href="data:text/css;charset=utf-8,body%20%7B%0Abackground%2Dcolor%3A%20%23fff%3B%0Amargin%3A%201em%20auto%3B%0Amax%2Dwidth%3A%20700px%3B%0Aoverflow%3A%20visible%3B%0Apadding%2Dleft%3A%202em%3B%0Apadding%2Dright%3A%202em%3B%0Afont%2Dfamily%3A%20%22Open%20Sans%22%2C%20%22Helvetica%20Neue%22%2C%20Helvetica%2C%20Arial%2C%20sans%2Dserif%3B%0Afont%2Dsize%3A%2014px%3B%0Aline%2Dheight%3A%201%2E35%3B%0A%7D%0A%23TOC%20%7B%0Aclear%3A%20both%3B%0Amargin%3A%200%200%2010px%2010px%3B%0Apadding%3A%204px%3B%0Awidth%3A%20400px%3B%0Aborder%3A%201px%20solid%20%23CCCCCC%3B%0Aborder%2Dradius%3A%205px%3B%0Abackground%2Dcolor%3A%20%23f6f6f6%3B%0Afont%2Dsize%3A%2013px%3B%0Aline%2Dheight%3A%201%2E3%3B%0A%7D%0A%23TOC%20%2Etoctitle%20%7B%0Afont%2Dweight%3A%20bold%3B%0Afont%2Dsize%3A%2015px%3B%0Amargin%2Dleft%3A%205px%3B%0A%7D%0A%23TOC%20ul%20%7B%0Apadding%2Dleft%3A%2040px%3B%0Amargin%2Dleft%3A%20%2D1%2E5em%3B%0Amargin%2Dtop%3A%205px%3B%0Amargin%2Dbottom%3A%205px%3B%0A%7D%0A%23TOC%20ul%20ul%20%7B%0Amargin%2Dleft%3A%20%2D2em%3B%0A%7D%0A%23TOC%20li%20%7B%0Aline%2Dheight%3A%2016px%3B%0A%7D%0Atable%20%7B%0Amargin%3A%201em%20auto%3B%0Aborder%2Dwidth%3A%201px%3B%0Aborder%2Dcolor%3A%20%23DDDDDD%3B%0Aborder%2Dstyle%3A%20outset%3B%0Aborder%2Dcollapse%3A%20collapse%3B%0A%7D%0Atable%20th%20%7B%0Aborder%2Dwidth%3A%202px%3B%0Apadding%3A%205px%3B%0Aborder%2Dstyle%3A%20inset%3B%0A%7D%0Atable%20td%20%7B%0Aborder%2Dwidth%3A%201px%3B%0Aborder%2Dstyle%3A%20inset%3B%0Aline%2Dheight%3A%2018px%3B%0Apadding%3A%205px%205px%3B%0A%7D%0Atable%2C%20table%20th%2C%20table%20td%20%7B%0Aborder%2Dleft%2Dstyle%3A%20none%3B%0Aborder%2Dright%2Dstyle%3A%20none%3B%0A%7D%0Atable%20thead%2C%20table%20tr%2Eeven%20%7B%0Abackground%2Dcolor%3A%20%23f7f7f7%3B%0A%7D%0Ap%20%7B%0Amargin%3A%200%2E5em%200%3B%0A%7D%0Ablockquote%20%7B%0Abackground%2Dcolor%3A%20%23f6f6f6%3B%0Apadding%3A%200%2E25em%200%2E75em%3B%0A%7D%0Ahr%20%7B%0Aborder%2Dstyle%3A%20solid%3B%0Aborder%3A%20none%3B%0Aborder%2Dtop%3A%201px%20solid%20%23777%3B%0Amargin%3A%2028px%200%3B%0A%7D%0Adl%20%7B%0Amargin%2Dleft%3A%200%3B%0A%7D%0Adl%20dd%20%7B%0Amargin%2Dbottom%3A%2013px%3B%0Amargin%2Dleft%3A%2013px%3B%0A%7D%0Adl%20dt%20%7B%0Afont%2Dweight%3A%20bold%3B%0A%7D%0Aul%20%7B%0Amargin%2Dtop%3A%200%3B%0A%7D%0Aul%20li%20%7B%0Alist%2Dstyle%3A%20circle%20outside%3B%0A%7D%0Aul%20ul%20%7B%0Amargin%2Dbottom%3A%200%3B%0A%7D%0Apre%2C%20code%20%7B%0Abackground%2Dcolor%3A%20%23f7f7f7%3B%0Aborder%2Dradius%3A%203px%3B%0Acolor%3A%20%23333%3B%0Awhite%2Dspace%3A%20pre%2Dwrap%3B%20%0A%7D%0Apre%20%7B%0Aborder%2Dradius%3A%203px%3B%0Amargin%3A%205px%200px%2010px%200px%3B%0Apadding%3A%2010px%3B%0A%7D%0Apre%3Anot%28%5Bclass%5D%29%20%7B%0Abackground%2Dcolor%3A%20%23f7f7f7%3B%0A%7D%0Acode%20%7B%0Afont%2Dfamily%3A%20Consolas%2C%20Monaco%2C%20%27Courier%20New%27%2C%20monospace%3B%0Afont%2Dsize%3A%2085%25%3B%0A%7D%0Ap%20%3E%20code%2C%20li%20%3E%20code%20%7B%0Apadding%3A%202px%200px%3B%0A%7D%0Adiv%2Efigure%20%7B%0Atext%2Dalign%3A%20center%3B%0A%7D%0Aimg%20%7B%0Abackground%2Dcolor%3A%20%23FFFFFF%3B%0Apadding%3A%202px%3B%0Aborder%3A%201px%20solid%20%23DDDDDD%3B%0Aborder%2Dradius%3A%203px%3B%0Aborder%3A%201px%20solid%20%23CCCCCC%3B%0Amargin%3A%200%205px%3B%0A%7D%0Ah1%20%7B%0Amargin%2Dtop%3A%200%3B%0Afont%2Dsize%3A%2035px%3B%0Aline%2Dheight%3A%2040px%3B%0A%7D%0Ah2%20%7B%0Aborder%2Dbottom%3A%204px%20solid%20%23f7f7f7%3B%0Apadding%2Dtop%3A%2010px%3B%0Apadding%2Dbottom%3A%202px%3B%0Afont%2Dsize%3A%20145%25%3B%0A%7D%0Ah3%20%7B%0Aborder%2Dbottom%3A%202px%20solid%20%23f7f7f7%3B%0Apadding%2Dtop%3A%2010px%3B%0Afont%2Dsize%3A%20120%25%3B%0A%7D%0Ah4%20%7B%0Aborder%2Dbottom%3A%201px%20solid%20%23f7f7f7%3B%0Amargin%2Dleft%3A%208px%3B%0Afont%2Dsize%3A%20105%25%3B%0A%7D%0Ah5%2C%20h6%20%7B%0Aborder%2Dbottom%3A%201px%20solid%20%23ccc%3B%0Afont%2Dsize%3A%20105%25%3B%0A%7D%0Aa%20%7B%0Acolor%3A%20%230033dd%3B%0Atext%2Ddecoration%3A%20none%3B%0A%7D%0Aa%3Ahover%20%7B%0Acolor%3A%20%236666ff%3B%20%7D%0Aa%3Avisited%20%7B%0Acolor%3A%20%23800080%3B%20%7D%0Aa%3Avisited%3Ahover%20%7B%0Acolor%3A%20%23BB00BB%3B%20%7D%0Aa%5Bhref%5E%3D%22http%3A%22%5D%20%7B%0Atext%2Ddecoration%3A%20underline%3B%20%7D%0Aa%5Bhref%5E%3D%22https%3A%22%5D%20%7B%0Atext%2Ddecoration%3A%20underline%3B%20%7D%0A%0Acode%20%3E%20span%2Ekw%20%7B%20color%3A%20%23555%3B%20font%2Dweight%3A%20bold%3B%20%7D%20%0Acode%20%3E%20span%2Edt%20%7B%20color%3A%20%23902000%3B%20%7D%20%0Acode%20%3E%20span%2Edv%20%7B%20color%3A%20%2340a070%3B%20%7D%20%0Acode%20%3E%20span%2Ebn%20%7B%20color%3A%20%23d14%3B%20%7D%20%0Acode%20%3E%20span%2Efl%20%7B%20color%3A%20%23d14%3B%20%7D%20%0Acode%20%3E%20span%2Ech%20%7B%20color%3A%20%23d14%3B%20%7D%20%0Acode%20%3E%20span%2Est%20%7B%20color%3A%20%23d14%3B%20%7D%20%0Acode%20%3E%20span%2Eco%20%7B%20color%3A%20%23888888%3B%20font%2Dstyle%3A%20italic%3B%20%7D%20%0Acode%20%3E%20span%2Eot%20%7B%20color%3A%20%23007020%3B%20%7D%20%0Acode%20%3E%20span%2Eal%20%7B%20color%3A%20%23ff0000%3B%20font%2Dweight%3A%20bold%3B%20%7D%20%0Acode%20%3E%20span%2Efu%20%7B%20color%3A%20%23900%3B%20font%2Dweight%3A%20bold%3B%20%7D%20%0Acode%20%3E%20span%2Eer%20%7B%20color%3A%20%23a61717%3B%20background%2Dcolor%3A%20%23e3d2d2%3B%20%7D%20%0A" rel="stylesheet" type="text/css" />




</head>

<body>




<h1 class="title toc-ignore">Troubleshooting with glmmTMB</h1>
<h4 class="date">2020-07-01</h4>



<p>This vignette covers common problems that occur while using <code>glmmTMB</code>. The contents will expand with experience.</p>
<p>If your problem is not covered below, there’s a chance it has been solved in the development version; try updating to the latest version of <code>glmmTMB</code> on GitHub.</p>
<div id="warnings" class="section level1">
<h1>Warnings</h1>
<div id="model-convergence-problem-non-positive-definite-hessian-matrix-na-values-for-likelihoodaicetc." class="section level2">
<h2>Model convergence problem; non-positive-definite Hessian matrix; NA values for likelihood/AIC/etc.</h2>
<p>This warning (<code>Model convergence problem; non-positive-definite Hessian matrix</code>) states that at <code>glmmTMB</code>’s maximum-likelihood estimate, the curvature of the negative log-likelihood surface is inconsistent with <code>glmmTMB</code> really having found the best fit (minimum): instead, the surface is downward-curving, or flat, in some direction(s).</p>
<p>It will usually be accompanied by <code>NA</code> values for the standard errors, log-likelihood, AIC, and BIC, and deviance. When you run <code>summary()</code> on the resulting model, you’ll get the warning <code>In sqrt(diag(vcov)) : NaNs produced</code>.</p>
<p>These problems are most likely:</p>
<ul>
<li>when a model is overparameterized (i.e. the data does not contain enough information to estimate the parameters reliably)</li>
<li>when a random-effect variance is estimated to be zero, or random-effect terms are estimated to be perfectly correlated (“singular fit”: often caused by having too few levels of the random-effect grouping variable)</li>
<li>when zero-inflation is estimated to be near zero (a strongly negative zero-inflation parameter)</li>
<li>when dispersion is estimated to be near zero</li>
<li>when <em>complete separation</em> occurs in a binomial model: some categories in the model contain proportions that are either all 0 or all 1</li>
</ul>
<p>How do we diagnose the problem?</p>
<div id="example-1." class="section level3">
<h3>Example 1.</h3>
<p>Consider this example:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">zinbm0 =<span class="st"> </span><span class="kw">glmmTMB</span>(count<span class="op">~</span>spp <span class="op">+</span><span class="st"> </span>(<span class="dv">1</span><span class="op">|</span>site), <span class="dt">zi=</span><span class="op">~</span>spp, Salamanders, <span class="dt">family=</span>nbinom2)</code></pre></div>
<p>First, see if any of the estimated coefficients are extreme. If you’re using a non-identity link function (e.g. log, logit), then parameter values with <span class="math inline">\(|\beta|&gt;10\)</span> are suspect (for a logit link, this implies probabilities very close to 0 or 1; for a log link, this implies mean counts that are close to 0 or extremely large).</p>
<p>Inspecting the fixed-effect estimates for this model:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">fixef</span>(zinbm0)</code></pre></div>
<p>The zero-inflation intercept parameter is tiny (<span class="math inline">\(\approx -17\)</span>): since the parameters are estimated on the logit scale, we back-transform with <code>plogis(-17)</code> to see the at the zero-inflation probability for the baseline level is about <span class="math inline">\(4 \times 10^{-8}\)</span>)). Many of the other ZI parameters are very large, compensating for the intercept: the estimated zero-inflation probabilities for all species are</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">ff &lt;-<span class="st"> </span><span class="kw">fixef</span>(zinbm0)<span class="op">$</span>zi
<span class="kw">round</span>(<span class="kw">plogis</span>(<span class="kw">c</span>(<span class="dt">sppGP=</span><span class="kw">unname</span>(ff[<span class="dv">1</span>]),ff[<span class="op">-</span><span class="dv">1</span>]<span class="op">+</span>ff[<span class="dv">1</span>])),<span class="dv">3</span>)</code></pre></div>
<p>Since the baseline probability is already effectively zero, making the intercept parameter larger or smaller will have very little effect - the likelihood is flat, which leads to the non-positive-definite warning.</p>
<p>Now that we suspect the problem is in the zero-inflation component, we can try to come up with ways of simplifying the model: for example, we could use a model that compared the first species (“GP”) to the rest:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">Salamanders &lt;-<span class="st"> </span><span class="kw">transform</span>(Salamanders, <span class="dt">GP=</span><span class="kw">as.numeric</span>(spp<span class="op">==</span><span class="st">&quot;GP&quot;</span>))
zinbm0_A =<span class="st"> </span><span class="kw">update</span>(zinbm0, <span class="dt">ziformula=</span><span class="op">~</span>GP)</code></pre></div>
<p>This fits without a warning, although the GP zero-inflation parameter is still extreme:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">fixef</span>(zinbm0_A)[[<span class="st">&quot;zi&quot;</span>]]</code></pre></div>
<p>Another possibility would be to fit the variation among species in the zero-inflation parameter as a random effect, rather than a fixed effect: this is slightly more parsimonious. This again fits without an error, although both the average level of zero-inflation and the among-species variation are estimated as very small:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">zinbm0_B =<span class="st"> </span><span class="kw">update</span>(zinbm0, <span class="dt">ziformula=</span><span class="op">~</span>(<span class="dv">1</span><span class="op">|</span>spp))
<span class="kw">fixef</span>(zinbm0_B)[[<span class="st">&quot;zi&quot;</span>]]
<span class="kw">VarCorr</span>(zinbm0_B)</code></pre></div>
<!-- FIXME: updating here does weird things
zinbm1 = update(zinbm0, ziformula=~mined, Salamanders, family=nbinom2)
-->
<p>The original analysis considered variation in zero-inflation by site status (mined or not mined) rather than by species - this simpler model only tries to estimate two parameters (mined + difference between mined and no-mining) rather than 7 (one per species) for the zero-inflation model.</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">zinbm1 =<span class="st"> </span><span class="kw">glmmTMB</span>(count<span class="op">~</span>spp <span class="op">+</span><span class="st"> </span>(<span class="dv">1</span><span class="op">|</span>site), <span class="dt">zi=</span><span class="op">~</span>mined, Salamanders, <span class="dt">family=</span>nbinom2)
<span class="kw">fixef</span>(zinbm1)[[<span class="st">&quot;zi&quot;</span>]]</code></pre></div>
<p>This again fits without a warning, but we see that the zero-inflation is effectively zero in the unmined (“minedno”) condition (<code>plogis(0.38-17.5)</code> is approximately <span class="math inline">\(4 \times 10^{-8}\)</span>). We can estimate the confidence interval, but it takes some extra work: the default Wald standard errors and confidence intervals are useless in this case.</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">## at present we need to specify the parameter by number; for
##  extreme cases need to specify the parameter range
## (not sure why the upper bound needs to be so high ... ?)
cc =<span class="st"> </span><span class="kw">confint</span>(zinbm1,<span class="dt">method=</span><span class="st">&quot;uniroot&quot;</span>,<span class="dt">parm=</span><span class="dv">9</span>, <span class="dt">parm.range=</span><span class="kw">c</span>(<span class="op">-</span><span class="dv">20</span>,<span class="dv">20</span>))
<span class="kw">print</span>(cc)</code></pre></div>
<p>The lower CI is not defined; the upper CI is -2.08, i.e. we can state that the zero-inflation probability is less than <code>plogis(-2.08)</code> = 0.11.</p>
<p>More broadly, general inspection of the data (e.g., plotting the response against potential covariates) should help to diagnose overly complex models.</p>
</div>
<div id="example-2." class="section level3">
<h3>Example 2.</h3>
<p>In some cases, scaling predictor variables may help. For example, in this example from <span class="citation">@phisanti</span>, the results of <code>glm</code> and <code>glmmTMB</code> applied to a scaled version of the data set agree, while <code>glmmTMB</code> applied to the raw data set gives a non-positive-definite Hessian warning.</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">## data taken from gamlss.data:plasma, originally
## http://biostat.mc.vanderbilt.edu/wiki/pub/Main/DataSets/plasma.html
<span class="kw">load</span>(<span class="kw">system.file</span>(<span class="st">&quot;vignette_data&quot;</span>,<span class="st">&quot;plasma.rda&quot;</span>, <span class="dt">package=</span><span class="st">&quot;glmmTMB&quot;</span>))
m4.<span class="dv">1</span> &lt;-<span class="st"> </span><span class="kw">glm</span>(calories <span class="op">~</span><span class="st"> </span>fat<span class="op">*</span>fiber, <span class="dt">family =</span> <span class="kw">Gamma</span>(<span class="dt">link =</span> <span class="st">&quot;log&quot;</span>), <span class="dt">data =</span> plasma)
m4.<span class="dv">2</span> &lt;-<span class="st"> </span><span class="kw">glmmTMB</span>(calories <span class="op">~</span><span class="st"> </span>fat<span class="op">*</span>fiber, <span class="dt">family =</span> <span class="kw">Gamma</span>(<span class="dt">link =</span> <span class="st">&quot;log&quot;</span>), <span class="dt">data =</span> plasma)
ps  &lt;-<span class="st"> </span><span class="kw">transform</span>(plasma,<span class="dt">fat=</span><span class="kw">scale</span>(fat,<span class="dt">center=</span><span class="ot">FALSE</span>),<span class="dt">fiber=</span><span class="kw">scale</span>(fiber,<span class="dt">center=</span><span class="ot">FALSE</span>))
m4.<span class="dv">3</span> &lt;-<span class="st"> </span><span class="kw">update</span>(m4.<span class="dv">2</span>, <span class="dt">data=</span>ps)
## scaling factor for back-transforming standard deviations
ss &lt;-<span class="st"> </span><span class="kw">c</span>(<span class="dv">1</span>,
        fatsc &lt;-<span class="st"> </span><span class="dv">1</span><span class="op">/</span><span class="kw">attr</span>(ps<span class="op">$</span>fat,<span class="st">&quot;scaled:scale&quot;</span>),
        fibsc &lt;-<span class="st"> </span><span class="dv">1</span><span class="op">/</span><span class="kw">attr</span>(ps<span class="op">$</span>fiber,<span class="st">&quot;scaled:scale&quot;</span>),
        fatsc<span class="op">*</span>fibsc)
## combine SEs, suppressing the warning from the unscaled model
s_vals &lt;-<span class="st"> </span><span class="kw">cbind</span>(<span class="dt">glm=</span><span class="kw">sqrt</span>(<span class="kw">diag</span>(<span class="kw">vcov</span>(m4.<span class="dv">1</span>))),
                <span class="dt">glmmTMB_unsc=</span><span class="kw">suppressWarnings</span>(<span class="kw">sqrt</span>(<span class="kw">diag</span>(<span class="kw">vcov</span>(m4.<span class="dv">2</span>)<span class="op">$</span>cond))),
                <span class="dt">glmmTMB_sc=</span><span class="kw">sqrt</span>(<span class="kw">diag</span>(<span class="kw">vcov</span>(m4.<span class="dv">3</span>)<span class="op">$</span>cond))<span class="op">*</span>ss)
<span class="kw">print</span>(s_vals,<span class="dt">digits=</span><span class="dv">3</span>)</code></pre></div>
</div>
</div>
<div id="example-3." class="section level2">
<h2>Example 3.</h2>
<p>Here is another example (from Samantha Sherman):</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">load</span>(<span class="kw">system.file</span>(<span class="st">&quot;vignette_data&quot;</span>,<span class="st">&quot;troubleshooting.rda&quot;</span>,<span class="dt">package=</span><span class="st">&quot;glmmTMB&quot;</span>))</code></pre></div>
<p>The first model gives the specified warning when it runs, as well as the other symptoms such as <code>NA</code> values for the likelihood:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">summary</span>(mod1)</code></pre></div>
<p>We can immediately see that the dispersion is very small and that the zero-inflation parameter is strongly negative. However, we’ll develop some fancier machinery that checks the variance-covariance matrix or Hessian of the model, finds eigenvalues that are negative or close to zero, and identifies which model components contribute to those eigenvalues:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">diagnose_vcov &lt;-<span class="st"> </span><span class="cf">function</span>(model, <span class="dt">tol=</span><span class="fl">1e-5</span>, <span class="dt">digits=</span><span class="dv">2</span>, <span class="dt">analyze_hessian=</span><span class="ot">FALSE</span>) {
    vv &lt;-<span class="st"> </span><span class="kw">vcov</span>(model, <span class="dt">full=</span><span class="ot">TRUE</span>)
    nn &lt;-<span class="st"> </span><span class="kw">rownames</span>(vv)
    <span class="cf">if</span> (<span class="op">!</span><span class="kw">all</span>(<span class="kw">is.finite</span>(vv))) {
        <span class="cf">if</span> (<span class="kw">missing</span>(analyze_hessian)) <span class="kw">warning</span>(<span class="st">&quot;analyzing Hessian, not vcov&quot;</span>)
        <span class="cf">if</span> (<span class="op">!</span>analyze_hessian) <span class="kw">stop</span>(<span class="st">&quot;can't analyze vcov&quot;</span>)
        analyze_hessian &lt;-<span class="st"> </span><span class="ot">TRUE</span>
    }
    <span class="cf">if</span> (analyze_hessian) {
        par.fixed &lt;-<span class="st"> </span>model<span class="op">$</span>obj<span class="op">$</span>env<span class="op">$</span>last.par.best
        r &lt;-<span class="st"> </span>model<span class="op">$</span>obj<span class="op">$</span>env<span class="op">$</span>random
        <span class="cf">if</span> (<span class="op">!</span><span class="kw">is.null</span>(r)) par.fixed &lt;-<span class="st"> </span>par.fixed[<span class="op">-</span>r]
        vv &lt;-<span class="st"> </span><span class="kw">optimHess</span>(par.fixed, <span class="dt">fn=</span>model<span class="op">$</span>obj<span class="op">$</span>fn, <span class="dt">gr=</span>model<span class="op">$</span>obj<span class="op">$</span>gr)
        ## note vv is now HESSIAN, not vcov
    }
    ee &lt;-<span class="st"> </span><span class="kw">eigen</span>(vv)
    <span class="cf">if</span> (<span class="kw">all</span>(ee<span class="op">$</span>values<span class="op">&gt;</span>tol)) {<span class="kw">message</span>(<span class="st">&quot;var-cov matrix OK&quot;</span>); <span class="kw">return</span>(<span class="kw">invisible</span>(<span class="ot">NULL</span>))}
    ## find negative or small-positive eigenvalues (flat/wrong curvature)
    bad_evals &lt;-<span class="st"> </span><span class="kw">which</span>(ee<span class="op">$</span>values<span class="op">&lt;</span>tol)
    ## order worst to best
    bad_evals &lt;-<span class="st"> </span>bad_evals[<span class="kw">order</span>(<span class="op">-</span>ee<span class="op">$</span>values[bad_evals])]
    ret &lt;-<span class="st"> </span><span class="kw">lapply</span>(bad_evals,
                  <span class="cf">function</span>(i) {
                      ## extract loadings
                      v &lt;-<span class="st"> </span><span class="kw">setNames</span>(ee<span class="op">$</span>vectors[,i], nn)
                      ## order in decreasing magnitude &amp; round
                      <span class="kw">list</span>(<span class="dt">val=</span>ee<span class="op">$</span>values[i],<span class="dt">vec=</span><span class="kw">round</span>(v[<span class="kw">order</span>(<span class="op">-</span><span class="kw">abs</span>(v))],digits))
                  })
    <span class="kw">return</span>(ret)
}</code></pre></div>
<p>Running the diagnostics on the model:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">(d1 &lt;-<span class="st"> </span><span class="kw">diagnose_vcov</span>(mod1))</code></pre></div>
<p>This model has a very bad eigenvalue that is mostly driven by the zero-inflation parameter, and a little bit by the dispersion parameter. Let’s try dropping the zero-inflation term:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">mod2 &lt;-<span class="st"> </span><span class="kw">update</span>(mod1, <span class="dt">ziformula=</span><span class="op">~</span><span class="dv">0</span>)</code></pre></div>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">summary</span>(mod2)</code></pre></div>
<p>We still get the warning, and the <code>NA</code>-valued likelihoods (and the very small dispersion parameter). Diagnose:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">diagnose_vcov</span>(mod2)</code></pre></div>
<p>We can see that the dispersion parameter is still problematic. Simplify the model by switching from NB1 to Poisson:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">mod3 &lt;-<span class="st"> </span><span class="kw">update</span>(mod2, <span class="dt">family=</span>poisson)</code></pre></div>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">summary</span>(mod3)</code></pre></div>
<p>There are no warnings, the model looks OK now, and the diagnostic function agrees:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r"><span class="kw">diagnose_vcov</span>(mod3)</code></pre></div>
<p>You can also check directly whether the model is OK by examining the <code>pdHess</code> (“positive-definite Hessian”) component of the <code>sdr</code> (“standard deviation report”) component of the model:</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">mod3<span class="op">$</span>sdr<span class="op">$</span>pdHess                       </code></pre></div>
<p>(<strong>FIXME</strong>: add an accessor method for this?)</p>
<p>In general models with non-positive definite Hessian matrices should be excluded from further consideration.</p>
</div>
<div id="model-convergence-problem-eigenvalue-problems" class="section level2">
<h2>Model convergence problem: eigenvalue problems</h2>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">m1 =<span class="st"> </span><span class="kw">glmmTMB</span>(count<span class="op">~</span>spp <span class="op">+</span><span class="st"> </span>mined <span class="op">+</span><span class="st"> </span>(<span class="dv">1</span><span class="op">|</span>site), <span class="dt">zi=</span><span class="op">~</span>spp <span class="op">+</span><span class="st"> </span>mined, Salamanders, <span class="dt">family=</span>genpois)</code></pre></div>
<p>In this example, the fixed-effect covariance matrix is <code>NaN</code>. It may have to do with the generalized Poisson (<code>genpois</code>) distribution, which is known to have convergence problems; luckily, the negative binomial (<code>nbinom1</code> and <code>nbinom2</code>) and/or Conway-Maxwell Poisson (<code>compois</code>) are good alternatives.</p>
<p>Models with convergence problems should be excluded from further consideration, in general.</p>
<p>In some cases, extreme eigenvalues may be caused by having predictor variables that are on very different scales: try rescaling, and centering, continuous predictors in the model.</p>
</div>
<div id="nanan-function-evaluation" class="section level2">
<h2>NA/NaN function evaluation</h2>
<blockquote>
<p>Warning in nlminb(start = par, objective = fn, gradient = gr) : NA/NaN function evaluation</p>
</blockquote>
<p>This warning occurs when the optimizer visits a region of parameter space that is invalid. It is not a problem as long as the optimizer has left that region of parameter space upon convergence, which is indicated by an absence of the model convergence warnings described above.</p>
<p>The following warnings indicate possibly-transient numerical problems with the fit, and can be treated in the same way (i.e. ignored if there are no errors or convergence warnings about the final fitted model).</p>
<blockquote>
<p>Cholmod warning ‘matrix not positive definite’</p>
</blockquote>
<p>In older versions of R (&lt; 3.6.0):</p>
<blockquote>
<p>Warning in f(par, order = order, …) : value out of range in ‘lgamma’</p>
</blockquote>
</div>
<div id="false-convergence" class="section level2">
<h2>false convergence</h2>
<p>This warning:</p>
<blockquote>
<p>false convergence: the gradient ∇f(x) may be computed incorrectly, the other stopping tolerances may be too tight, or either f or ∇f may be discontinuous near the current iterate x</p>
</blockquote>
<p>comes from the <code>nlminb</code> optimizer used by default in <code>glmmTMB</code>. It’s usually hard to diagnose the source of this warning (this <a href="https://stackoverflow.com/questions/40039114/r-nlminb-what-does-false-convergence-actually-mean">Stack Overflow answer</a> explains a bit more about what it means). Reasonable methods for making sure your model is OK are:</p>
<ul>
<li>restart the model at the estimated fitted values</li>
<li>try using a different optimizer, e.g. <code>control=glmmTMBControl(optimizer=optim, optArgs=list(method=&quot;BFGS&quot;))</code></li>
</ul>
<p>and see if the results are sufficiently similar to the original fit.</p>
</div>
</div>
<div id="errors" class="section level1">
<h1>Errors</h1>
<div id="nanan-gradient-evaluation" class="section level2">
<h2>NA/NaN gradient evaluation</h2>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">dat1 =<span class="st"> </span><span class="kw">expand.grid</span>(<span class="dt">y=</span><span class="op">-</span><span class="dv">1</span><span class="op">:</span><span class="dv">1</span>, <span class="dt">rep=</span><span class="dv">1</span><span class="op">:</span><span class="dv">10</span>)
m1 =<span class="st"> </span><span class="kw">glmmTMB</span>(y<span class="op">~</span><span class="dv">1</span>, dat1, <span class="dt">family=</span>nbinom2)</code></pre></div>
<p>The error occurs here because the negative binomial distribution is inappropriate for data with negative values.</p>
<p>If you see this error, check that the response variable meets the assumptions of the specified distribution.</p>
</div>
<div id="gradient-length" class="section level2">
<h2>gradient length</h2>
<blockquote>
<p>Error in nlminb(start = par, objective = fn, gradient = gr) : gradient function must return a numeric vector of length x</p>
</blockquote>
<blockquote>
<p>Error in optimHess(par.fixed, obj<span class="math inline">\(fn, obj\)</span>gr): gradient in optim evaluated to length x</p>
</blockquote>
<p>Try rescaling predictor variables. Try a simpler model and build up. (If you have a simple reproducible example of these errors, please post them to the issues list.)</p>
<div id="inspecting-hessian-experimental" class="section level3">
<h3>inspecting Hessian (experimental!)</h3>
<p>Can we directly inspect the Hessian to find where the problems are?</p>
<div class="sourceCode"><pre class="sourceCode r"><code class="sourceCode r">##' @param fit a \code{glmmTMB} fit
##' @param h Hessian (if not provided, will be computed from the Jacobian of the gradient
##' @param eval.eps numeric tolerance for 'bad' eigenvalues
##' @param evec.eps numeric tolerance for 'bad' eigenvector elements
diagnose_hessian &lt;-<span class="st"> </span><span class="cf">function</span>(fit,<span class="dt">h=</span><span class="ot">NULL</span>, <span class="dt">eval.eps=</span><span class="fl">1e-5</span>,<span class="dt">evec.eps=</span><span class="fl">1e-2</span>) {
    ## pull out the TMB object from the fit
    obj &lt;-<span class="st"> </span>fit<span class="op">$</span>obj
    ee &lt;-<span class="st"> </span><span class="kw">environment</span>(obj<span class="op">$</span>fn)
    ## extract parameters
    pp &lt;-<span class="st"> </span>ee<span class="op">$</span>last.par[<span class="op">-</span>ee<span class="op">$</span>random]
    ## easiest way to get names corresponding to all of the parameters
    nn &lt;-<span class="st"> </span><span class="kw">tryCatch</span>(<span class="kw">colnames</span>(<span class="kw">vcov</span>(fit,<span class="dt">full=</span><span class="ot">TRUE</span>)),
                   ## fall-back position
                   <span class="dt">error =</span> <span class="cf">function</span>(e) <span class="kw">make.unique</span>(<span class="kw">names</span>(pp)))
    ## fit$sdr$pdHess
    <span class="cf">if</span> (<span class="st">&quot;sdr&quot;</span> <span class="op">%in%</span><span class="st"> </span><span class="kw">names</span>(fit)) {
        <span class="kw">cat</span>(<span class="st">&quot;bad params according to sdreport:&quot;</span>,
            <span class="kw">paste</span>(nn[<span class="op">!</span><span class="kw">is.finite</span>(<span class="kw">suppressWarnings</span>(<span class="kw">sqrt</span>(<span class="kw">diag</span>(fit<span class="op">$</span>sdr<span class="op">$</span>cov.fixed))))],
                  <span class="dt">collapse=</span><span class="st">&quot;, &quot;</span>),<span class="st">&quot;</span><span class="ch">\n</span><span class="st">&quot;</span>)
    }
    ## two ways to compute the Hessian
    ## (1) directly from the objective function, via finite difference+Richardson extrapolation
    ## h1 &lt;- hessian(obj$fn, pp)
    ## (2) use the gradient and compute its Jacobian (faster and probably more stable)
    <span class="cf">if</span> (<span class="kw">is.null</span>(h)) {
        <span class="cf">if</span> (<span class="op">!</span><span class="kw">require</span>(numDeriv)) <span class="kw">stop</span>(<span class="st">&quot;need numDeriv package installed&quot;</span>) 
        h &lt;-<span class="st"> </span><span class="kw">jacobian</span>(obj<span class="op">$</span>gr, pp)
    }
    ## double-check we get the same answer (approximately)
    ## all.equal(h1,h,tolerance=1e-5)
    ## now investigate the Hessian
    eigs &lt;-<span class="st"> </span><span class="kw">eigen</span>(h)
    ## non-positive definite means some of the eigenvectors are &lt;= 0
    bad &lt;-<span class="st"> </span><span class="kw">which</span>(eigs<span class="op">$</span>values<span class="op">/</span><span class="kw">max</span>(eigs<span class="op">$</span>values)<span class="op">&lt;=</span>eval.eps)
    <span class="cf">if</span> (<span class="kw">length</span>(bad)<span class="op">==</span><span class="dv">0</span>) {
        <span class="kw">cat</span>(<span class="st">&quot;Hessian seems OK</span><span class="ch">\n</span><span class="st">&quot;</span>)
        <span class="kw">return</span>(<span class="kw">invisible</span>(h))
    }
    <span class="kw">cat</span>(<span class="kw">sprintf</span>(<span class="st">&quot;max eigenvalue = %1.3g&quot;</span>,eigs<span class="op">$</span>values[<span class="dv">1</span>]),<span class="st">&quot;</span><span class="ch">\n</span><span class="st">&quot;</span>)
    <span class="cf">for</span> (b <span class="cf">in</span> bad) {  ## there could be more than one 'bad' direction/eigenvector ..
        <span class="kw">cat</span>(<span class="kw">sprintf</span>(<span class="st">&quot;Hessian eigenvalue %d = %1.3g (relative val = %1.3g)&quot;</span>,
                    b,eigs<span class="op">$</span>values[b],eigs<span class="op">$</span>values[b]<span class="op">/</span>eigs<span class="op">$</span>values[<span class="dv">1</span>]),<span class="st">&quot;</span><span class="ch">\n</span><span class="st">&quot;</span>)
        bad_vec &lt;-<span class="st"> </span>eigs<span class="op">$</span>vectors[,b]
        bad_elements &lt;-<span class="st"> </span><span class="kw">which</span>(<span class="kw">abs</span>(bad_vec)<span class="op">&gt;</span>evec.eps)
        <span class="kw">cat</span>(<span class="st">&quot;   bad elements:&quot;</span>,nn[bad_elements],<span class="st">&quot;</span><span class="ch">\n</span><span class="st">&quot;</span>)
    }
    <span class="kw">cat</span>(<span class="st">&quot;SDs computed from sqrt(diag(solve(H))):&quot;</span>,
        <span class="kw">paste</span>(<span class="kw">suppressWarnings</span>(<span class="kw">sqrt</span>(<span class="kw">diag</span>(<span class="kw">solve</span>(h)))), <span class="dt">collapse=</span><span class="st">&quot;, &quot;</span>),<span class="st">&quot;</span><span class="ch">\n</span><span class="st">&quot;</span>)
    <span class="kw">return</span>(<span class="kw">invisible</span>(h))
}
<span class="kw">diagnose_hessian</span>(zinbm0)</code></pre></div>
</div>
</div>
</div>



<!-- code folding -->


<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
